# moretype/moretype.pyi

"""Hi!"""

from typing import *

class Link:
    def __init__(self, *args: Any, target: Optional[List[Any]] = None) -> None: ...
    def __str__(self) -> str: ...
    def __getitem__(self, index: Union[int, slice]) -> Union[Any, 'Link']: ...
    def append(self, item: Any) -> None: ...
    def insert(self, index: int, item: Any) -> None: ...
    def remove(self, item: Any) -> None: ...
    def pop(self, index: int = -1) -> Any: ...
    def reverse(self) -> None: ...
    def show(self) -> None: ...
    def get(self, index: Optional[int] = None, cut: Optional[int] = None, sci: Optional[int] = None) -> Union[Any, 'Link']: ...
    def _update_data(self) -> None: ...

class Rect:
    def __init__(self, width: Optional[int] = None, height: Optional[int] = None, target: Optional[List[List[Any]]] = None) -> None: ...
    def __str__(self) -> str: ...
    def __getitem__(self, index: Union[int, slice, Tuple[Union[int, slice], Union[int, slice]]]) -> Union[Any, 'Rect']: ...
    def __add__(self, other: Union['Rect', int, float]) -> 'Rect': ...
    def __radd__(self, other: Union['Rect', int, float]) -> 'Rect': ...
    def __sub__(self, other: Union['Rect', int, float]) -> 'Rect': ...
    def __rsub__(self, other: Union['Rect', int, float]) -> 'Rect': ...
    def __mul__(self, other: Union['Rect', int, float]) -> 'Rect': ...
    def __rmul__(self, other: Union['Rect', int, float]) -> 'Rect': ...
    def __pow__(self, power: int) -> 'Rect': ...
    def set_value(self, row: int, col: int, value: Any) -> None: ...
    def get_value(self, row: int, col: int) -> Any: ...
    def show(self) -> None: ...

class Array:
    def __init__(self, *args: Any, data: Optional[List[Any]] = None) -> None: ...
    def __str__(self) -> str: ...
    def __getitem__(self, index: Union[int, slice]) -> Union[Any, 'Array']: ...
    def __add__(self, other: Union['Array', int, float]) -> 'Array': ...
    def __radd__(self, other: Union['Array', int, float]) -> 'Array': ...
    def __sub__(self, other: Union['Array', int, float]) -> 'Array': ...
    def __rsub__(self, other: Union['Array', int, float]) -> 'Array': ...
    def __mul__(self, other: Union['Array', int, float]) -> 'Array': ...
    def __rmul__(self, other: Union['Array', int, float]) -> 'Array': ...
    def __truediv__(self, other: Union['Array', int, float]) -> 'Array': ...
    def __rtruediv__(self, other: Union['Array', int, float]) -> 'Array': ...
    def sum(self) -> float: ...
    def mean(self) -> float: ...
    def sort(self) -> 'Array': ...
    def append(self, value: Any) -> None: ...
    def insert(self, index: int, value: Any) -> None: ...
    def remove(self, value: Any) -> Any: ...
    def get_value(self, index: int) -> Any: ...
    def set_value(self, index: int, value: Any) -> None: ...
    def show(self) -> None: ...

class Database:
    def __init__(self, db_name: str = 'database') -> None: ...
    def __str__(self) -> str: ...
    def load(self) -> None: ...
    def save(self) -> None: ...
    def insert(self, data: Any, key: Optional[str] = None) -> None: ...
    def remove(self, key: str, value: Optional[Any] = None) -> None: ...
    def get(self) -> List[Any]: ...
    def clear(self) -> None: ...